function A=A1d(a,b,n)
% A1D one dimensional finite difference approximation
%   A=A1d(a,b,J) computes a sparse finite difference
%   approximation of the one dimensional operator -Delta on the
%   domain Omega=(a,b) using n interior points

h=(b-a)/(n+1);
e=ones(n,1);
A=1/h^2*spdiags([-e 2*e -e],[-1 0 1],n,n);
