function A=A2d(eta,nx,ny);
% A2D finite difference approximation of eta-Delta in 2d
%     A=A2d(eta,nx,ny); constructs the finite difference approximation to
%     eta-Delta on a nx x ny grid with spacing h=1/(ny+1) and homogeneous
%     Dirichlet conditions all around

h=1/(ny+1);

e=eta+4/h^2*ones(nx*ny,1);               % diagonal of the discrete Laplacian
e1=-1/h^2*repmat([ones(ny-1,1);0],nx,1);
e2=-1/h^2*ones(nx*ny,1);
B=zeros(nx*ny,3);
B(1:length(e2),1)=e2;               % prepare format for spdiags
B(1:length(e1),2)=e1;
B(1:length(e),3)=e;
B(1:length(e1),4)=flipud(e1);       % flipud because of spdiags conventions
B(1:length(e2),5)=flipud(e2);

A=spdiags(B,[-ny -1 0 1 ny],nx*ny,nx*ny); 





