function [L,U]=MyLU_sanspivot(A)
% MYLU_SANSPIVOT  compute the LU factorization of A
%              [L,U]=MyLU_sanspivot(A) computes a lower triangular matrix 
%              L and an upper triangular matrix U such that A=L*U,
%              using Gauss elimination without pivoting.
%

[m,n]=size(A);                             
L=eye(size(A));
U=A;
for i=1:n-1,
  for j=i+1:m,                           
    L(j,i)=U(j,i)/U(i,i);
    U(j,i)=0;
    for k=i+1:n,
      U(j,k)=U(j,k)-L(j,i)*U(i,k);
    end;
  end;
end;


